#include "maibu_res.h"
#include "maibu_sdk.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*窗口句柄*/
static int32_t g_window = -1;

static uint8_t mon_days = 0;

P_Window init_watch();
void window_reloading(void);

//重新载入并刷新窗口所有图层
void window_reloading(void)
{
  /*根据窗口ID获取窗口句柄*/
  P_Window p_old_window = (P_Window)app_window_stack_get_window_by_id(g_window);
  if (NULL != p_old_window)
  {
    P_Window p_window = init_watch();
    if (NULL != p_window)
    {
      g_window = app_window_stack_replace_window(p_old_window, p_window);
    }
  }
}

void watch_time_change(enum SysEventType type, void *context)
{
  /*时间更改*/
  if (type == SysEventTypeTimeChange)
  {
    window_reloading();
  }
}

/*创建并显示图层，需要坐标值，得到icon_key的数组，数组需要的参数值，P_Window*/
int32_t display_target_layer(P_Window p_window, GRect *temp_p_frame, int32_t bmp_array_name_key)
{
  GBitmap bmp_point;
  res_get_user_bitmap(bmp_array_name_key, &bmp_point);
  LayerBitmap layer_bitmap_struct_l = {bmp_point, *temp_p_frame, GAlignLeft};
  P_Layer temp_P_Layer = app_layer_create_bitmap(&layer_bitmap_struct_l);

  if (temp_P_Layer != NULL)
  {
    //app_layer_set_bg_color(temp_P_Layer, GColorBlack);
    return app_window_add_layer(p_window, temp_P_Layer);
  }

  return 0;
}

int32_t display_target_layerText(P_Window p_window, const GRect *temp_p_frame, enum GAlign how_to_align, enum GColor color, char *str, uint8_t font_type)
{
  LayerText temp_LayerText = {0};
  temp_LayerText.text = str;
  temp_LayerText.frame = *temp_p_frame;
  temp_LayerText.alignment = how_to_align;
  temp_LayerText.font_type = font_type;
  //temp_LayerText.foregroundColor = fcolor;

  P_Layer p_layer = app_layer_create_text(&temp_LayerText);

  if (p_layer != NULL)
  {
    app_layer_set_bg_color(p_layer, color);
    return app_window_add_layer(p_window, p_layer);
  }

  return 0;
}

P_Window init_watch()
{
  char buff[30] = {0};
  P_Window p_window = app_window_create();
  if (NULL == p_window)
    return NULL;
  struct date_time dt;
  app_service_get_datetime(&dt);

  GRect frame = {{0, 0}, {32, 128}};
  sprintf(buff, "%d:%02d", dt.hour, dt.min);
  display_target_layerText(p_window, &frame, GAlignCenter, GColorWhite, buff, U_ASCII_ARIAL_30);

  SLunarData sld = {0};
  maibu_get_lunar_calendar(NULL, &sld);
  frame.origin.x = 0;
  frame.origin.y = 32;
  frame.size.h = 12;
  frame.size.w = 128;
  sprintf(buff, "%d-%d-%d", dt.year, dt.mon, dt.mday);
  display_target_layerText(p_window, &frame, GAlignLeft, GColorWhite, buff, U_ASCII_ARIAL_12);
  sprintf(buff, "%s%s", sld.mon, sld.day);
  display_target_layerText(p_window, &frame, GAlignRight, GColorWhite, buff, U_ASCII_ARIAL_12);

  frame.origin.x = 0;
  frame.origin.y = 46;
  frame.size.h = 15;
  frame.size.w = 128;
  display_target_layer(p_window, &frame, RES_BG);

  //计算本月天数
  if (dt.mon == 1 || dt.mon == 3 || dt.mon == 5 || dt.mon == 7 || dt.mon == 8 || dt.mon == 10 || dt.mon == 12)
    mon_days = 31;
  else if (dt.mon == 4 || dt.mon == 6 || dt.mon == 9 || dt.mon == 11)
    mon_days = 30;
  else if (dt.year % 4 == 0 && dt.year % 100 != 0 || dt.year % 400 == 0)
    mon_days = 29;
  else
    mon_days = 28;

  int8_t i, j = 1, first_day = dt.wday - (dt.mday - 1) % 7;
  if (first_day < 0)
    first_day = first_day + 7;
  memset(buff, 0, sizeof(buff));

  //第一行
  char tmp[5] = {0};
  for (i = 1; i <= 7 - first_day; i++)
  {
    sprintf(tmp, "%02d ", j);
    strcat(buff, tmp);
    j++;
  }
  buff[strlen(buff) - 1] = '\0';
  frame.origin.y = 64;
  frame.size.h = 12;
  frame.size.w = 121;
  display_target_layerText(p_window, &frame, GAlignRight, GColorWhite, buff, U_ASCII_ARIAL_12);

  //第二行
  memset(buff, 0, sizeof(buff));
  memset(tmp, 0, sizeof(tmp));
  for (i = 1; i <= 7; i++)
  {
    sprintf(tmp, "%02d ", j);
    strcat(buff, tmp);
    j++;
  }
  buff[strlen(buff) - 1] = '\0';
  frame.origin.y = 77;
  frame.size.h = 12;
  frame.size.w = 121;
  display_target_layerText(p_window, &frame, GAlignRight, GColorWhite, buff, U_ASCII_ARIAL_12);

  //第三行
  memset(buff, 0, sizeof(buff));
  memset(tmp, 0, sizeof(tmp));
  for (i = 1; i <= 7; i++)
  {
    sprintf(tmp, "%02d ", j);
    strcat(buff, tmp);
    j++;
  }
  buff[strlen(buff) - 1] = '\0';
  frame.origin.y = 90;
  frame.size.h = 12;
  frame.size.w = 121;
  display_target_layerText(p_window, &frame, GAlignRight, GColorWhite, buff, U_ASCII_ARIAL_12);

  //第四行
  memset(buff, 0, sizeof(buff));
  memset(tmp, 0, sizeof(tmp));
  for (i = 1; i <= 7; i++)
  {
    sprintf(tmp, "%02d ", j);
    strcat(buff, tmp);
    j++;
  }
  buff[strlen(buff) - 1] = '\0';
  frame.origin.y = 103;
  frame.size.h = 12;
  frame.size.w = 121;
  display_target_layerText(p_window, &frame, GAlignRight, GColorWhite, buff, U_ASCII_ARIAL_12);

  //第五行
  if (j < mon_days)
  {
    memset(buff, 0, sizeof(buff));
    memset(tmp, 0, sizeof(tmp));
    for (i = 1; i <= 7 && j <= mon_days; i++)
    {
      sprintf(tmp, "%02d ", j);
      strcat(buff, tmp);
      j++;
    }
    buff[strlen(buff) - 1] = '\0';
    frame.origin.x = 5;
    frame.origin.y = 116;
    frame.size.h = 12;
    frame.size.w = 121;
    display_target_layerText(p_window, &frame, GAlignLeft, GColorWhite, buff, U_ASCII_ARIAL_12);
  }
  //多余的放第一行
  if (j <= mon_days)
  {
    memset(buff, 0, sizeof(buff));
    memset(tmp, 0, sizeof(tmp));
    for (i = 1; i <= 7 && j <= mon_days; i++)
    {
      sprintf(tmp, "%02d ", j);
      strcat(buff, tmp);
      j++;
    }
    buff[strlen(buff) - 1] = '\0';
    frame.origin.x = 4;
    frame.origin.y = 64;
    frame.size.h = 12;
    frame.size.w = 120;
    display_target_layerText(p_window, &frame, GAlignLeft, GColorWhite, buff, U_ASCII_ARIAL_12);
  }
  //标记当天
  int x = 3 + 17 * ((dt.mday + first_day - 1) % 7);
  int y = 64 + 13 * ((dt.mday + first_day-1) / 7);
  if (y > 128)
    y = y - 65;
  sprintf(buff, "%02d ", dt.mday);
  frame.origin.x = x;
  frame.origin.y = y;
  frame.size.h = 13;
  frame.size.w = 17;
  display_target_layerText(p_window, &frame, GAlignRight, GColorBlack, buff, U_ASCII_ARIAL_12);

  return p_window;
}

int main()
{
  simulator_init();

  P_Window p_window = init_watch();
  if (p_window != NULL)
  {
    g_window = app_window_stack_push(p_window);
  }

  maibu_service_sys_event_subscribe(watch_time_change);

  simulator_wait();
  return 0;
}
